package s1peqe.ejb.cmp.rob.client;

import javax.naming.*;
import javax.rmi.*;
import s1peqe.ejb.cmp.rob.ejb.session.*;
import s1peqe.ejb.cmp.rob.ejb.*;
import s1peqe.ejb.cmp.rob.ejb.unknownpk.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.rmi.*;
import javax.ejb.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class StockTestClient {
	
	Context ctx;
        public RobSessionRemoteHome srobHome;
        public RobSessionRemote srob, srob1, srob2, srob3, srob4, srob5, srob6, srob7 ;
	Object ref;
        SimpleReporterAdapter stat = new SimpleReporterAdapter("sqe-pe");
        public static String testSuiteID="read-only-bean-cmp";
       	//Construct the EJB Client
        
public StockTestClient(){
	
    try {
		ctx = new InitialContext();
		ref = ctx.lookup("java:comp/env/ejb/MyRobSession");  
		stat.addDescription("This test will be testing for cmp rob");
		srobHome = (RobSessionRemoteHome) PortableRemoteObject.narrow(ref,RobSessionRemoteHome.class);
                stat.addStatus(testSuiteID+" "+"Init",stat.PASS);
	}

	catch(Exception ex){
            
		 stat.addStatus(testSuiteID+" "+"Init",stat.FAIL);
		 ex.printStackTrace();	
	}
}

public void addStock() {

 try {    
    srob = srobHome.create();
    srob.add_stock();
    } catch (Exception ex) {
        System.out.println("failed to add SUNW ");
        ex.printStackTrace();
    }
 
}

public void addBook() {

 try {    
       srob = srobHome.create();
       srob.add_book();
       
     } catch (Exception ex) {
        System.out.println("failed to add Champak ... ");
        ex.printStackTrace();
    }
 
}

public void addComp() {

 try {    
       srob = srobHome.create();
       srob.add_composite();
       
     } catch (Exception ex) {
        System.out.println("failed to add comp key ... ");
        ex.printStackTrace();
    }
 
}

public void addBlob(String imagefile) {

    boolean result=false;
try {    
    byte blobdata[] = readBlobData(imagefile);
    String clobdata = "CLOBDATA-string";
    srob = srobHome.create();
    result = srob.add_blob(new java.lang.Long("111"), blobdata, clobdata);  
    if ( result == true ){      
          stat.addStatus("ReadOnly-BLOB-Adddata", stat.PASS);
    } else {
        stat.addStatus("ReadOnly-BLOB-Adddata", stat.FAIL);
    }                
} catch (Exception ex) {
        stat.addStatus("ReadOnly-BLOB-Adddata", stat.FAIL);
        System.out.println("failed to add blob data ... ");
        ex.printStackTrace();
  }
 
}

 
public byte[] readBlobData(String imagefile) {
    
   boolean result=false;
   File imgFile = new File(imagefile);
   long imgFileSize= imgFile.length();
   byte byteValue[] = new byte[(int)imgFileSize];
 try {    
   InputStream is = new BufferedInputStream(new FileInputStream(imgFile));            
   int len = is.read(byteValue);
   if(len!=imgFileSize) {
      System.out.println("The image file length read " +  len + "did not equal file size" + imgFileSize );
    }    
} catch(Exception ex) {
    System.out.println("Error reading image file");
    ex.printStackTrace();
}
   return byteValue;
}

public void test_timebased_blob_NotSpported(String imagefile){
    boolean result=false;
  try {    
    byte blobdata[] = readBlobData(imagefile);
    srob = srobHome.create();
    System.out.println("Executing rob test ... ");
    result = srob.blob_transaction_NotSupported(new java.lang.Long("111"), blobdata);
    if ( result == true ){      
             stat.addStatus("ReadOnly-TimeBased-BLOB-NotSupported", stat.PASS);
                 }
         else {
             stat.addStatus("ReadOnly-TimeBased-BLOB-NotSupported", stat.FAIL);
              }                
     }  catch (Exception ex){
         stat.addStatus("ReadOnly-TimeBased-BLOB-NotSupported", stat.FAIL);
         ex.printStackTrace();
     }
    
}

public void test_timebased_clob_NotSpported(){
    boolean result=false;
  try {    
    srob = srobHome.create();
    System.out.println("Executing rob test ... ");
    result = srob.clob_transaction_NotSupported(new java.lang.Long("111"));
    if ( result == true ){      
             stat.addStatus("ReadOnly-TimeBased-CLOB-NotSupported", stat.PASS);
                 }
         else {
             stat.addStatus("ReadOnly-TimeBased-CLOB-NotSupported", stat.FAIL);
              }                
     }  catch (Exception ex){
         stat.addStatus("ReadOnly-TimeBased-CLOB-NotSupported", stat.FAIL);
         ex.printStackTrace();
     }
    
}



public void test_timebased_NotSupported(){
      
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_NotSupported("SUNW");
         if ( result == true ){      
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-NotSupported", stat.PASS);
                 }
         else {
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-NotSupported", stat.FAIL);
              }                
     }  catch (Exception ex){
         stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-NotSupported", stat.FAIL);
         ex.printStackTrace();
     }
     
}

public void test_timebased_Never(){
      
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_Never("SUNW");
                  
          if ( result == true ){      
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Never", stat.PASS);
                    }
               else {
                        stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Never", stat.FAIL);
                    }   
     }  catch (Exception ex){
         stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Never", stat.FAIL);
         ex.printStackTrace();
     }
     
}

public void test_timebased_RequiresNew(){
      
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_RequiresNew("SUNW");
                  
          if ( result == true ){      
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-RequiresNew", stat.PASS);
                    }
               else {
                       stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-RequiresNew", stat.FAIL);
                    }   
     }  catch (Exception ex){
         
         stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-RequiresNew", stat.FAIL);
         ex.printStackTrace();
     }
     
}

public void test_timebased_Required(){
      
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_Required("SUNW");
                  
          if ( result == true ){      
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Required", stat.PASS);
                    }
               else {
                stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Required", stat.FAIL);
                    }   
     }  catch (Exception ex){
         stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Required", stat.FAIL);
         ex.printStackTrace();
     }
     
}

public void test_timebased_Mandatory(){
      
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_Mandatory("SUNW");
                  
          if (result == true ){      
            stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Mandatory", stat.PASS);
                  }
          else {
             stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Mandatory", stat.FAIL);
               }   
     }  catch (Exception ex){
          stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-Mandatory", stat.FAIL);
          ex.printStackTrace();
     }
     
}

public void test_timebased_SupportsWithTx(){
      
   boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_SupportsWithTx("SUNW");
         
     if (result == true ){      
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithTx", stat.PASS);
               }
        else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithTx", stat.FAIL);
            }   
     }  catch (Exception ex){
          stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithTx", stat.FAIL);
          ex.printStackTrace();
     }
     
}

public void test_timebased_SupportsWithoutTx(){
      
   boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_transaction_SupportsWithoutTx("SUNW");
         
     if (result == true ){      
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithoutTx", stat.PASS);
               }
        else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithoutTx", stat.FAIL);
            }   
     }  catch (Exception ex){
          stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-SupportsWithoutTx", stat.FAIL);
          ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_NotSupported(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_NotSupported();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-NotSupported", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-NotSupported", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-NotSupported", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_Never(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_Never();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Never", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Never", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Never", stat.FAIL);
           ex.printStackTrace();
     }
     
}


public void test_timebased_unknownpk_RequiresNew(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_RequiresNew();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-RequiresNew", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-RequiresNew", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-RequiresNew", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_Required(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_Required();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Required", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Required", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Required", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_Mandatory(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_Mandatory();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Mandatory", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Mandatory", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-Mandatory", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_SupportsWithTx(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_SupportsWithTx();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithTx", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithTx", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithTx", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_unknownpk_SupportsWithoutTx(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.unknownpk_transaction_SupportsWithoutTx();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithoutTx", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithoutTx", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-unknownpk-SupportsWithoutTx", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_timebased_ckey_NotSupported(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.ckey_transaction_NotSupported();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-ckey-NotSupported", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-ckey-NotSupported", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-TimeBased-Refresh-ckey-NotSupported", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_add_stock_Negative(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.add_stock_Negative();
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-Negative-Create", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-Negative-Create", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-Negative-Create", stat.FAIL);
           ex.printStackTrace();
     }
     
}

public void test_rob_setter_Negative(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_setter_Negative("SUNW");
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-Negative-Setter", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-Negative-Setter", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-Negative-Setter", stat.FAIL);
           ex.printStackTrace();
     }
     
}


public void test_rob_remove_Negative(){
    
    boolean result=false;
    
     try {
         srob = srobHome.create();
         result = srob.rob_remove_Negative("SUNW");
         if (result == true) {
           stat.addStatus("ReadOnly-Stock-Negative-Remove", stat.PASS);
         } else {
           stat.addStatus("ReadOnly-Stock-Negative-Remove", stat.FAIL);
         }
     }  catch (Exception ex){
           stat.addStatus("ReadOnly-Stock-Negative-Remove", stat.FAIL);
           ex.printStackTrace();
     }
     
}


 public void printSummary()
 {
      stat.printSummary("CMP_ROB_TEST");
 }


public static void main(String[] args) {
    
	StockTestClient client = new StockTestClient();
        String imagefile = args[0];
        String image2 = args[1];
        System.out.println("The image file name is :" + imagefile);
        // Add data 
        client.addStock();
        client.addBook();
        client.addComp(); 
        client.addBlob(imagefile);
        // ROB tests for BLOB/CLOB
        // System.out.println("Executing test rob_blob_NotSupported");
        //client.test_timebased_blob_NotSpported(image2);
        //client.test_timebased_clob_NotSpported();
        // ROB tests for different transactions .......     
        System.out.println("Executing test rob_transaction_NotSupported ");
        client.test_timebased_NotSupported();
        /*
        System.out.println("Executing test rob_transaction_Never ");
        client.test_timebased_Never();
        System.out.println("Executing test rob_transaction_RequiresNew ");
        client.test_timebased_RequiresNew(); 
        System.out.println("Executing test rob_transaction_Required");
        client.test_timebased_Required();
        System.out.println("Executing test rob_transaction_Mandatory");
        client.test_timebased_Mandatory(); 
        System.out.println("Executing test rob_transaction_SupportsWithTx");
        client.test_timebased_SupportsWithTx();
        System.out.println("Executing test rob_transaction_SupportsWithoutTx");
        client.test_timebased_SupportsWithoutTx(); 
        // ROB for UnknownPK tests .....
         System.out.println("Executing test rob_unknownpk_NotSupported ");
         client.test_timebased_unknownpk_NotSupported();
         System.out.println("Executing test rob_unknownpk_Never ");
         client.test_timebased_unknownpk_Never();
         System.out.println("Executing test rob_unknownpk_RequiresNew ");
         client.test_timebased_unknownpk_RequiresNew();
         System.out.println("Executing test rob_unknownpk_Required ");
         client.test_timebased_unknownpk_Required(); 
         System.out.println("Executing test rob_unknownpk_Mandatory");
         client.test_timebased_unknownpk_Mandatory();
         System.out.println("Executing test rob_unknownpk_SupportsWithTx");
         client.test_timebased_unknownpk_SupportsWithTx();
         System.out.println("Executing test rob_unknownpk_SupportsWithoutTx");
         client.test_timebased_unknownpk_SupportsWithoutTx(); 
         // Composite Primary Key Test
         client.test_timebased_ckey_NotSupported();
         // Negative Tests ....         
         client.test_add_stock_Negative();  
         client.test_rob_setter_Negative();
         client.test_rob_remove_Negative();
         */
         //
         client.printSummary();
        
}

}

		
		
		
