package s1peqe.ejb.cmp.rob.ejb.session;

import s1peqe.ejb.cmp.rob.ejb.*;
import s1peqe.ejb.cmp.rob.ejb.unknownpk.*;
import s1peqe.ejb.cmp.rob.ejb.composite.*;
import s1peqe.ejb.cmp.rob.ejb.lob.*;
import java.rmi.RemoteException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.naming.Context;
import javax.ejb.*;
import java.util.*;
import java.text.*;
import com.sun.ejb.containers.*;
import com.sun.ejb.*;

public class RobSessionBean implements javax.ejb.SessionBean {
        
	public SessionContext sessionContext;
	public Context context;
        StockLocal stockrw1, stockrw2, stockrw3 = null;
        StockRobLocal stockr = null;
        StockLocalHome stockrwHome;
        StockRobLocalHome stockrHome;
        public BookLocal book1;
        public BookLocalHome bookHome;
        public BookRobLocal bookr1;
        public BookRobLocalHome bookrHome;
        public CompositeLocalHome compositeHome;
        public CompositeLocal compLocal;
        public CompositeRobLocalHome compositerHome;
        public CompositeRobLocal comprLocal;
        public LobLocal lob1, lob2;
        public LobLocalHome lobHome;
        public LobRobLocal lobr1;
        public LobRobLocalHome lobrHome;
        
public void add_stock() throws Exception {
   
    try {
             
    SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
    String date = "09-15-1976 15:52";
    long timeInMillis = sdf.parse(date).getTime ();
    java.sql.Timestamp timestamp=new java.sql.Timestamp(timeInMillis);  
    java.lang.Integer int1 = new java.lang.Integer(3000);
    stockrw1 = stockrwHome.create("SUNW",new Float(4.50),timestamp, new Float(1.50),new Float(6.00), int1, "Sun Microsystems"); 
    
    } catch (Exception ex) {
        System.out.println("add stock failed ...");
        ex.printStackTrace();
    }
    
}

public void add_book() throws Exception {
   
    try {        
          book1 = bookHome.create("champak", "comic book", 123456789, "Shaila", "Publish1", new Float("10.20"), new Integer("30")); 
          System.out.println("Added book ...");
        } catch (Exception ex) {
        System.out.println("add stock failed ...");
        ex.printStackTrace();
    }
    
}

public void add_composite() throws Exception {
   
    try {
             
    compLocal = compositeHome.create(new CompositeKey("shaila", "middleField"), "mountain view"); 
    
    } catch (Exception ex) {
        System.out.println("add composite Key entry failed ...");
        ex.printStackTrace();
    }
    
}

public boolean add_blob(java.lang.Long empno, byte[] blobdata, String clobdata) {
    
    boolean ret=false;
    
    try {   
         // byte[] blobrec = new byte[blobdata.length]; 
          lob1 = lobHome.create(empno, blobdata, clobdata); 
          System.out.println("Added BLOB data ...");
          
          lob2= lobHome.findByPrimaryKey(empno);
          byte[] blobrec = lob2.getPic();
          if (blobdata.length != blobrec.length ){
             System.out.println("The length of the blobrec " + blobrec.length + " did not match the expected value " + blobdata.length ); 
             ret=false;
          } else {
              System.out.println("The length of the blobrec " + blobrec.length + " matched the expected value " + blobdata.length ); 
          ret=true;
          }
        } catch (Exception ex) {
            ret=false;
           System.out.println("add BLOB data failed ...");
           ex.printStackTrace();
    }
   
   return ret;
    
}

//Negative tests 

public boolean add_stock_Negative() throws Exception {
   boolean ret=false;
    try {   
          stockr = stockrHome.create("YAHO"); 
          ret=false;
        } catch (Exception ex) {
            ret=true;
           System.out.println("add stock failed ...");
           ex.printStackTrace();
    }
   return ret;    
}

public boolean rob_setter_Negative(String stockid) throws Exception {
     
      boolean ret=false;
       try{  
            String stockpk = stockid;
            stockr = stockrHome.findByPrimaryKey(stockpk);           
            stockr.setLastTrade(new Float("30.00"));
            ret=false;
            } catch(Exception ex) {
            ret=true;
            ex.printStackTrace();
               }
        return ret;
    } 

public boolean rob_remove_Negative(String stockid) throws Exception {
     
      boolean ret=false;
       try{  
            String stockpk = stockid;
            stockr = stockrHome.findByPrimaryKey(stockpk);           
            stockr.remove();
            ret=false;
            } catch(Exception ex) {
            ret=true;
            ex.printStackTrace();
               }
        return ret;
    } 

public boolean blob_transaction_NotSupported(Long empno, byte[] blobdata) throws Exception {
     
      boolean ret=false;
    
     try{  
            lobr1 = lobrHome.findByPrimaryKey(empno);    
            lob1 = lobHome.findByPrimaryKey(empno);
            byte[] beforeRefresh_pic1 = lobr1.getPic();
            int len1 = beforeRefresh_pic1.length;
            int len_blob = blobdata.length;
            System.out.println("The length of blobdata to be set is " + len_blob);
            lob1.setPic(blobdata);
            System.out.println("Sleeping for 65 secs");
            Thread.sleep(65000);           
            byte[] afterRefresh_pic1 = lobr1.getPic();
            int len2 = afterRefresh_pic1.length ;
            System.out.println("The len for image1 is " + len1);
            System.out.println("The len for image2 is " + len2);
            if (len1 == len2){                
              ret=false;
            } else {
              ret=true;
            }
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve bookName Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean clob_transaction_NotSupported(Long empno) throws Exception {
     
      boolean ret=false;
    
     try{  
            lobr1 = lobrHome.findByPrimaryKey(empno);    
            lob1 = lobHome.findByPrimaryKey(empno);
            String beforeRefresh_data1 = lobr1.getClobdata();
            lob1.setClobdata("CLOBDATA-changed");
            System.out.println("Sleeping for 65 secs");
            Thread.sleep(65000);           
            String afterRefresh_data1 = lobr1.getClobdata();
            if (beforeRefresh_data1.compareTo(afterRefresh_data1) == 0){                
              ret=false;
            } else {
              ret=true;
            }
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve data");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_NotSupported() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            String bookNameValueBeforeRefresh = bookr1.getBookName();
            System.out.println("The BookName Value from read bean before Refresh is : " + bookNameValueBeforeRefresh);
            book1.setBookName("Champak_new");
            Thread.sleep(65000);
            String bookNameValueAfterRefresh = bookr1.getBookName();
            System.out.println("The BookName Value from read bean after Refresh is : " + bookNameValueAfterRefresh);
            if ( bookNameValueBeforeRefresh.compareTo(bookNameValueAfterRefresh)== 0) {  
              ret=false;
            } else {
              ret=true;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve bookName Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_Never() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            String bookDescValueBeforeRefresh = bookr1.getBookDesc();
            System.out.println("The BookDesc Value from read bean before Refresh is : " + bookDescValueBeforeRefresh);
            book1.setBookDesc("Changed Desc");
            Thread.sleep(65000);
            String bookDescValueAfterRefresh = bookr1.getBookDesc();
            System.out.println("The BookDesc Value from read bean after Refresh is : " + bookDescValueAfterRefresh);
            if ( bookDescValueBeforeRefresh.compareTo(bookDescValueAfterRefresh)== 0) {  
              ret=false;
            } else {
              ret=true;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve bookDesc Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_RequiresNew() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            String publisherValueBeforeRefresh = bookr1.getPublisher();
            System.out.println("The publisher Value from read bean before Refresh is : " + publisherValueBeforeRefresh);
            book1.setPublisher("publisher_change");
            Thread.sleep(65000);
            String publisherValueAfterRefresh = bookr1.getPublisher();
            System.out.println("The publisher Value from read bean after Refresh is : " + publisherValueAfterRefresh);
            if ( publisherValueBeforeRefresh.compareTo(publisherValueBeforeRefresh)== 0) {  
              ret=true;
            } else {
              ret=false;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve publisher Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_Required() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            String authorValueBeforeRefresh = bookr1.getAuthor();
            System.out.println("The author Value from read bean before Refresh is : " + authorValueBeforeRefresh);
            book1.setAuthor("Shaila Rao");
            Thread.sleep(65000);
            String authorValueAfterRefresh = bookr1.getAuthor();
            System.out.println("The author Value from read bean after Refresh is : " + authorValueAfterRefresh);
            if ( authorValueBeforeRefresh.compareTo(authorValueAfterRefresh)== 0) {  
              ret=true;
            } else {
              ret=false;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve author Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_Mandatory() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            Float priceValueBeforeRefresh = bookr1.getPrice();
            System.out.println("The price Value from read bean before Refresh is : " + priceValueBeforeRefresh);
            book1.setPrice(new Float(10.20));
            Thread.sleep(65000);
            Float priceValueAfterRefresh = bookr1.getPrice();
            System.out.println("The price Value from read bean after Refresh is : " + priceValueAfterRefresh);
            if ( priceValueBeforeRefresh.compareTo(priceValueAfterRefresh)== 0) {  
              ret=true;
            } else {
              ret=false;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve price Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_SupportsWithTx() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            Integer pcountValueBeforeRefresh = bookr1.getPagecount();
            System.out.println("The pagecount Value from read bean before Refresh is : " + pcountValueBeforeRefresh);
            book1.setPagecount(new Integer(40));
            Thread.sleep(65000);
            Integer pcountValueAfterRefresh = bookr1.getPagecount();
            System.out.println("The pagecount Value from read bean after Refresh is : " + pcountValueAfterRefresh);
            if ( pcountValueBeforeRefresh.compareTo(pcountValueAfterRefresh)== 0) {  
              ret=true;
            } else {
              ret=false;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve pagecount Value");
                ex.printStackTrace();  
      }
      
      return ret;
}

public boolean unknownpk_transaction_SupportsWithoutTx() throws Exception {
     
      boolean ret=false;
    
     try{  
            Object bookpk =  book1.getPrimaryKey();   
            System.out.println("The PK value for Book is:" + bookpk.toString());
            bookr1 = bookrHome.findByPrimaryKey(bookpk);          
            int isbnValueBeforeRefresh = bookr1.getIsbn();
            System.out.println("The isbn Value from read bean before Refresh is : " + isbnValueBeforeRefresh);
            book1.setIsbn(11111111);
            Thread.sleep(65000);
            int isbnValueAfterRefresh = bookr1.getIsbn();
            System.out.println("The isbn Value from read bean after Refresh is : " + isbnValueAfterRefresh);
            if (isbnValueBeforeRefresh == isbnValueAfterRefresh) {  
              ret=false;
            } else {
              ret=true;
            }
           
         } catch(Exception  ex) {
             ret=false;
                System.out.println("Failed to retrieve isbn Value");
                ex.printStackTrace();  
      }
      
      return ret;
}


public boolean rob_transaction_NotSupported(String stockid) throws Exception {
     
      boolean ret=false;
       try{  
            String stockpk = stockid;
            stockrw2 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);           
            Float lastTradeValue = stockrw2.getLastTrade(); 
            Float lastTradeValueBeforeRefresh = stockr.getLastTrade();
            System.out.println("The lastTrade Value from read bean before Refresh is : " + lastTradeValueBeforeRefresh);
            stockrw2.setLastTrade(new java.lang.Float("25.00"));
            Thread.sleep(65000);
            Float lastTradeAfterRefresh = stockr.getLastTrade();
            System.out.println("The lastTrade value from the read Bean after Refresh: " +lastTradeAfterRefresh ); 
            if ( lastTradeValueBeforeRefresh.compareTo(lastTradeAfterRefresh)== 0) {
            ret=false;
            } else {
                ret=true;
            }
           } catch(Throwable e) {
            System.out.println("Failed to retrieve lastTrade Value");
            e.printStackTrace();
            ret=false;
            throw new Exception(e.getMessage());            
        }
        return ret;
    } 
   
public boolean rob_transaction_Never(String stockid) throws Exception {
     
      boolean ret=false;
      
       try{  
            String stockpk = stockid;
            stockrw2 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            Float closeValue = stockrw2.getClosetrade(); 
            Float closeValueBeforeRefresh = stockr.getClosetrade();
            System.out.println("The Close Value from read bean before Refresh is : " + closeValueBeforeRefresh);
            stockrw2.setClosetrade(new java.lang.Float("30.00"));
            Thread.sleep(65000);
            Float closeValueAfterRefresh = stockr.getClosetrade();
            System.out.println("The Close Value from read bean after Refresh is : " + closeValueAfterRefresh);
            if ( closeValueBeforeRefresh.compareTo(closeValueAfterRefresh) == 0){
                ret=false;
            } else {
                ret=true;
            }
           } catch(Exception ex) {
            System.out.println("Failed to retrieve close Value");
            ret=false;
            ex.printStackTrace();  
                  }
        return ret;
    } 

public boolean rob_transaction_RequiresNew(String stockid) throws Exception {
     
      boolean ret=false;
      
       try{  
            String stockpk = stockid;
            stockrw3 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            Float changeValueBeforeRefresh = stockr.getChange();
            System.out.println("The change Value from read bean before Refresh is : " + changeValueBeforeRefresh);
            stockrw3.setChange(new java.lang.Float("25.00"));
            Thread.sleep(65000);
            Float changeValueAfterRefresh = stockr.getChange();
            System.out.println("The change Value from read bean after Refresh is : " + changeValueAfterRefresh);
            if ( changeValueAfterRefresh.compareTo(changeValueBeforeRefresh) == 0){
                ret=true;
            } else {
                ret=false;
            }
           } catch(Exception ex) {
            System.out.println("Failed to retrieve change Value");
            ret=false;
            ex.printStackTrace();  
                  }
        return ret;
    } 

   public boolean rob_transaction_Required(String stockid) throws Exception {
     
    boolean ret=false;
      
     try{  
            String stockpk = stockid;
            stockrw3 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            String descValueBeforeRefresh = stockr.getDescr();
            System.out.println("The desc Value from read bean before Refresh is : " + descValueBeforeRefresh);
            stockrw3.setDescr("Changed the description");
            Thread.sleep(65000);
            String descValueAfterRefresh = stockr.getDescr();
            System.out.println("The desc Value from read bean after Refresh is : " + descValueAfterRefresh);
            if ( descValueAfterRefresh.compareTo(descValueBeforeRefresh) == 0){
                ret=true;
            } else {
                ret=false;
            }
           } catch(Exception ex) {
            System.out.println("Failed to retrieve desc Value");
            ret=false;
            ex.printStackTrace();  
                  }
        return ret;
    } 
   
  public boolean rob_transaction_Mandatory(String stockid) throws Exception {
       
   boolean ret=false;  
      
      try {                    
            String stockpk = stockid;
            stockrw3 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            Integer volumeValueBeforeRefresh = stockr.getVolume();
            System.out.println("The volume Value from read bean before Refresh is : " + volumeValueBeforeRefresh);
            stockrw3.setVolume(new java.lang.Integer(4000));
            Thread.sleep(65000);
            Integer volumeValueAfterRefresh = stockr.getVolume();
            System.out.println("The volume Value from read bean after Refresh is : " + volumeValueAfterRefresh);
            if ( volumeValueAfterRefresh.compareTo(volumeValueBeforeRefresh) == 0){
                ret=true;
            } else {
                ret=false;
            }
        } catch (Exception ex) {
               ret=false;
               System.out.println("Failed to retrieve Volume Value");
               ex.printStackTrace();  
             }
        return ret;
    } 
  
  public boolean rob_transaction_SupportsWithTx(String stockid) throws Exception {
       
   boolean ret=false;  
      
      try {       
          SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
          String date = "09-12-2004 15:52";
          long timeInMillis = sdf.parse(date).getTime();
          java.sql.Timestamp timestamp_new = new java.sql.Timestamp(timeInMillis);  
            String stockpk = stockid;
            stockrw3 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            java.sql.Timestamp timeBeforeRefresh = stockr.getTradeTime();
            System.out.println("The TradeTime from read bean before Refresh with Tx is : " + timeBeforeRefresh);
            stockrw3.setTradeTime(timestamp_new);
            Thread.sleep(65000);
            java.sql.Timestamp timeAfterRefresh = stockr.getTradeTime();
            System.out.println("The TradeTime Value from read bean after Refresh with Tx is : " + timeAfterRefresh);
            if (timeAfterRefresh.compareTo(timeBeforeRefresh) == 0){
                ret=true;
            } else {
                ret=false;
            }
        } catch (Exception ex) {
               ret=false;
               System.out.println("Failed to retrieve Timestamp");
               ex.printStackTrace();  
             }
        return ret;
    } 
  
   public boolean rob_transaction_SupportsWithoutTx(String stockid) throws Exception {
       
   boolean ret=false;  
      
      try {       
          SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
          String date = "05-10-2003 15:52:00";
          long timeInMillis = sdf.parse(date).getTime();
          java.sql.Timestamp timestamp_new = new java.sql.Timestamp(timeInMillis);  
            String stockpk = stockid;
            stockrw3 = stockrwHome.findByPrimaryKey(stockpk);
            stockr = stockrHome.findByPrimaryKey(stockpk);
            java.sql.Timestamp timeBeforeRefresh = stockr.getTradeTime();
            System.out.println("The TradeTime from read bean before Refresh without Tx is : " + timeBeforeRefresh);
            stockrw3.setTradeTime(timestamp_new);
            Thread.sleep(65000);
            java.sql.Timestamp timeAfterRefresh = stockr.getTradeTime();
            System.out.println("The TradeTime Value from read bean after Refresh without Tx is : " + timeAfterRefresh);
            int x = timeAfterRefresh.compareTo(timeBeforeRefresh);
            System.out.println("The comparision value is : " + x );
            if (timeAfterRefresh.compareTo(timeBeforeRefresh) == 0){
                ret=false;
            } else {
                ret=true;
            }
        } catch (Exception ex) {
               ret=false;
               System.out.println("Failed to retrieve Timestamp");
               ex.printStackTrace();  
             }
        return ret;
    } 
   
   public boolean ckey_transaction_NotSupported() throws Exception {
     
      boolean ret=false;
      
       try{  
            CompositeKey ckey = new CompositeKey("shaila", "middleField");           
            compLocal = compositeHome.findByPrimaryKey(ckey);
            comprLocal = compositerHome.findByPrimaryKey(ckey);
            // String city = compLocal.getCity();
            String CityValueBeforeRefresh = comprLocal.getCity();
            System.out.println("The city Value from read bean before Refresh is : " + CityValueBeforeRefresh);
            compLocal.setCity("Milpitas");
            Thread.sleep(65000);
            String CityValueAfterRefresh = comprLocal.getCity();
            System.out.println("The city Value from read bean after Refresh is : " + CityValueAfterRefresh);
            if (CityValueBeforeRefresh.compareTo(CityValueAfterRefresh) == 0){
                ret=false;
            } else {
                ret=true;
            }
            
           } catch(Exception e) {
               ret=false;
            System.out.println("Failed to retrieve city Value");
            e.printStackTrace();
           
               }
      return ret;
        } 
       
    private Context getInitialContext() throws NamingException 
    {
        return new InitialContext();
    }

    public void ejbCreate()throws CreateException {}
         
    public void ejbRemove(){}
      
    public void ejbActivate(){}
      
    public void ejbPassivate(){}
       
    public void setSessionContext(SessionContext cntx){
	 sessionContext = cntx;
         
      try {
               context = new InitialContext();   
               stockrwHome = (StockLocalHome) context.lookup("java:comp/env/ejb/StockLocal");   
               stockrHome = (StockRobLocalHome) context.lookup("java:comp/env/ejb/StockRobLocal");
               bookHome = (BookLocalHome) context.lookup("java:comp/env/ejb/BookLocal"); 
               bookrHome = (BookRobLocalHome) context.lookup("java:comp/env/ejb/BookRobLocal");
               compositeHome = (CompositeLocalHome) context.lookup("java:comp/env/ejb/CompositeLocal"); 
               compositerHome = (CompositeRobLocalHome) context.lookup("java:comp/env/ejb/CompositeRobLocal"); 
               lobHome = (LobLocalHome) context.lookup("java:comp/env/ejb/LobLocal"); 		          
               lobrHome = (LobRobLocalHome) context.lookup("java:comp/env/ejb/LobRobLocal"); 
               
        } catch(Exception e) {
	     e.printStackTrace();
	  }
    }
    
}
