package s1peqe.ejb.cmp.rob.ejb.session;

import java.rmi.RemoteException;
import javax.ejb.FinderException;
import s1peqe.ejb.cmp.rob.ejb.*;
import s1peqe.ejb.cmp.rob.ejb.unknownpk.*;

public interface RobSessionRemote extends javax.ejb.EJBObject {

    public boolean rob_transaction_NotSupported(String stockid) throws RemoteException;
    public boolean rob_transaction_Never(String stockid) throws RemoteException;
    public boolean rob_transaction_RequiresNew(String stockid) throws RemoteException;
    public boolean rob_transaction_Required(String stockid) throws RemoteException;
    public boolean rob_transaction_Mandatory(String stockid) throws RemoteException;
    public boolean rob_transaction_SupportsWithTx(String stockid) throws RemoteException;
    public boolean rob_transaction_SupportsWithoutTx(String stockid) throws RemoteException;
    // Unknown PK tests
    public boolean unknownpk_transaction_NotSupported() throws RemoteException;
    public boolean unknownpk_transaction_Never() throws RemoteException;
    public boolean unknownpk_transaction_RequiresNew() throws RemoteException;
    public boolean unknownpk_transaction_Required() throws RemoteException;
    public boolean unknownpk_transaction_Mandatory() throws RemoteException;
    public boolean unknownpk_transaction_SupportsWithTx() throws RemoteException;
    public boolean unknownpk_transaction_SupportsWithoutTx() throws RemoteException; 
    // composite PK tests 
    public boolean ckey_transaction_NotSupported() throws RemoteException;
    // Adding to database
    public void add_stock() throws RemoteException;
    public void add_book() throws RemoteException;
    public void add_composite() throws RemoteException;
    // Negative Scenarios
    public boolean add_stock_Negative() throws RemoteException;
    public boolean rob_setter_Negative(String stockid) throws RemoteException;
    public boolean rob_remove_Negative(String stockid) throws RemoteException;
    // LOB tests
    public boolean add_blob(Long empno, byte[] blobdata, String clobdata) throws RemoteException;
    public boolean blob_transaction_NotSupported(Long empno, byte[] blobdata) throws RemoteException; 
    public boolean clob_transaction_NotSupported(Long empno) throws RemoteException;
}
